* Gauss Chapter
drop _all
clear

use lbw
regress bwt lwt race2 race3 smoke ht ui

glm bwt lwt race2 race3 smoke ht ui

glm bwt lwt race2 race3 smoke ht ui, irls

insheet using beta.txt, clear
generate female = sex==2
generate pills = vitamin==1 | vitamin==2
glm betap age female pills kcal fat fiber alcohol chol betad
predict double res if e(sample), pearson
histogram res

histogram res
graph export gausshistres.eps, replace

sort res
generate nscore = invnormal(_n/316)
twoway scatter nscore res

twoway scatter nscore res
graph export gaussnscore.eps, replace
twoway scatter res kcal, yline(0)
graph export gaussreskcal.eps, replace

drop if kcal > 4000
glm betap age female pills kcal fat fiber alcohol chol betad, link(log) nolog
predict double betaphat if e(sample), mu
predict double resloglink if e(sample), pearson
histogram resloglink
twoway scatter resloglink betaphat, yline(0)

histogram resloglin
graph export gausshistresloglink.eps, replace
twoway scatter resloglink betaphat, yline(0)
graph export gaussresidplot.eps, replace

generate double logbetap = log(betap)
glm logbetap age female pills kcal fat fiber alcohol chol betad
predict double logbetaphat if e(sample), mu
predict double reslognormal if e(sample), pearson
histogram reslognormal

histogram reslognormal
graph export gausshistrespearson.eps, replace

twoway scatter reslognormal logbetaphat, yline(0)

sort reslognormal
generate nscorelb = invnormal(_n/312)
twoway scatter nscorelb reslognormal || line reslognormal reslognormal 
twoway scatter reslognormal kcal, yline(0)

twoway scatter reslognormal logbetaphat, yline(0)
graph export gausspresid.eps, replace
twoway scatter nscorelb reslognormal || line reslognormal reslognormal 
graph export gaussnscorelogbeta.eps, replace
twoway scatter reslognormal kcal, yline(0)
graph export gaussreslogbetakcal.eps, replace
